/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "configdialog.h"
#include "configform.h"
#include "qgridglobal.h"
#include <qpushbutton.h>
#include <qcombobox.h>
#include <qsettings.h>
#include "configform.h"
#include "utils.h"
/**
	\class configDialog 
	More detailed discription of the configdialog class
*/
QString docPath; //!< path to the documentation (default /usr/local/share)
QString myLocator;
bool useMiles;


/**
	constructor for configDialog
*/
configDialog::configDialog(QWidget *, const char *)
{
	readSettings();	
}

/**
	destructor for configDialog
*/
configDialog::~configDialog()
{
}
//! read variables from config file
/**
	Read the config file and initializes the variables. If not found, default values will be used.
	\sa writeSettings
	
*/
void configDialog::readSettings()
{
	QSettings qSettings(QSettings::Ini);
	docPath  =qSettings.readEntry(APP_KEY + "docPath",QString("/usr/share/doc/packages/qgrid"));
	myLocator  =qSettings.readEntry(APP_KEY + "myLocator","");
	useMiles=qSettings.readBoolEntry(APP_KEY + "useMiles",FALSE);
}

//! write variables to config file
/**
	Writes the variables to the config file.
	\sa readSettings
	
*/
void configDialog::writeSettings()
{
	QSettings qSettings(QSettings::Ini);
	qSettings.writeEntry( APP_KEY + "docPath",docPath);
	qSettings.writeEntry( APP_KEY + "myLocator",myLocator);
	qSettings.writeEntry( APP_KEY + "useMiles", useMiles);
}



void configDialog::exec()
{

	conf=new configForm(0);
	conf->setModal(FALSE);
	connect(conf->docPathBrowseButton,SIGNAL(clicked()),SLOT(slotBrowseDocPath()));
	setParams();
	
	if(conf->exec())
		{
	 		getParams();
			writeSettings();
		}
	delete conf;
}



void configDialog::setParams()
{
	setValue(docPath,conf->docPathLineEdit);
	setValue(useMiles,conf->useMilesCheckBox);
}

void configDialog::getParams()
{
	getValue(docPath,conf->docPathLineEdit);
	getValue(useMiles,conf->useMilesCheckBox);
}

void configDialog::slotBrowseDocPath()
{
	browseDir(conf->docPathLineEdit,docPath);
}

